Subject: bug#25513: closed (Re: bug#25513: Issue grepping lines ending with CRLF with --color=auto.)

From: [email-masked] (GNU bug Tracking System)
Date: Mon, 23 Jan 2017 17:14:02 +0000

Your bug report

#25513: Issue grepping lines ending with CRLF with --color=auto.

which was filed against the grep package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
25513: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=25513
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#25513: Issue grepping lines ending with CRLF with --color=auto.
From: Jim Meyering <[email-masked]>
To: Eric Hoffman <[email-masked]>
Cc: [email-masked]
Date: Mon, 23 Jan 2017 09:12:44 -0800
List-Id: <debbugs-submit.debbugs.gnu.org>

tags 25513 notabug
thanks

On Mon, Jan 23, 2017 at 8:03 AM, Eric Hoffman
<[email-masked]> wrote:
> grep is behaving differently when outputting with --color=auto when lines are ending with CRLF (like Windows text files).
>
> The issue is that if I have a file with CRLF line terminator, for example, a file named test.txt, containing:
> Line 1<CR><LF>
> Line 2<CR><LF>
> Line 3<CR><LF>
>
> Or:
>
> $od -c test.txt
> 0000000   L   i   n   e       1  \r  \n   L   i   n   e       2  \r  \n
> 0000020   L   i   n   e       3  \r  \n
> 0000030
>
> Then, If I type:
> $ grep --color=auto "." test.txt
...

Thank you for the report. I too see that behavior, but it is not a
problem with grep. It is due to the way carriage returns are rendered.
Here, even without --color, you can see that the three matched line
render as empty:

$ printf 'line%s\r\n' 1 2 3 | grep .

However, if you pipe that result through cat -A, you see that grep is
working as required:

$ printf 'line%s\r\n' 1 2 3 | grep .|cat -A
line1^M$
line2^M$
line3^M$

So I'm closing this bug.

Subject: Issue grepping lines ending with CRLF with --color=auto.
From: Eric Hoffman <[email-masked]>
To: "[email-masked]'" <[email-masked]>
Date: Mon, 23 Jan 2017 16:03:49 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello!

grep is behaving differently when outputting with --color=auto when lines are ending with CRLF (like Windows text files).

The issue is that if I have a file with CRLF line terminator, for example, a file named test.txt, containing:
Line 1<CR><LF>
Line 2<CR><LF>
Line 3<CR><LF>

Or:

$od -c test.txt
0000000   L   i   n   e       1  \r  \n   L   i   n   e       2  \r  \n
0000020   L   i   n   e       3  \r  \n
0000030

Then, If I type:
$ grep --color=auto "." test.txt

That is, I tell grep to display every lines containing at least one character (that is, every lines),  I get on terminal output just 3 empty lines.  However, if I type:
$ grep "." test.txt
Line 1
Line 2
Line 3

Then I do have every lines on the output.

I tried on both SSH and direct console with same result.

On my SSH terminal, I captured output, and what I see is
<CR><LF>
<CR><LF>
<CR><LF>

Here are a few variations:
- I tried with a longer file, like 100 lines, and I do get some of the lines printed, but truncated to the terminal screen width.
- The issue here was with printing every lines, but I do get the same result as long as I match any end of lines, like grep "2.*" test.txt, or even "grep 2[[:cntrl:]]$" test.txt
- The problem is there only when

This was with grep 2.27 (also tried 2.16, which I had before upgrading to 2.27).

Regards,
Eric